using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImpliziteKurve
{
    public partial class Form1 : Form
    {
        Bitmap bitmap;

        // TO DO: dieses Bild als Ressource einbetten
        Bitmap palette = (Bitmap)Bitmap.FromFile(@"..\..\palette.png");

        List<PointF> points = new List<PointF>();
        List<PointF> visitedGridPoints = new List<PointF>();

        const float grid = 5.0f;
        const double height = 0.5;

        public Form1()
        {
            InitializeComponent();

            // Bild zum Vergleich mal stur ausrechnen
            bitmap = new Bitmap(ClientSize.Width, ClientSize.Height);
            for (int i = 0; i < ClientSize.Width; i++)
            {
                for (int j = 0; j < ClientSize.Height; j++)
                {
                    int z = (int)Math.Min(255.9, Math.Max(0.0, 255.9 * f(i, j)));
                    // GetPixel und SetPixel sind sehr lahm,
                    // besser direkt auf den Binrdaten arbeiten
                    Color c = palette.GetPixel(z, 0);
                    bitmap.SetPixel(i, j, c);
                }
            }

            // Finde einen Punkt im Inneren.
            // Diese Lsung hier ist quick & dirty.
            Random random = new Random(1234);
            int x;
            int y;
            double v;
            do
            {
                x = random.Next(100) - 50;
                y = random.Next(100) - 50;
                v = f(grid * x, grid * y);
            }
            while(v < height);

            // Finde den ersten Punkt rechts auen.
            int x1 = x;
            double v1;
            do
            {
                x1++;
                v1 = f(grid * x1, grid * y);
            }
            while (v1 >= height);

            int xa = x1 - 1;
            int ya = y;
            double va = f(grid * xa, grid * ya);
            int xb = x1;
            int yb = y;
            double vb = v1;

            // marschiere um den Berg; a ist immer "oben", b ist immer "unten".
            do
            {
                // lineare Unterteilung der Strecke zwischen a und b
                float t = (float)((height - vb) / (va - vb));
                points.Add(new PointF(grid * (t*xa+(1-t)*xb), grid * (t*ya+(1-t)*yb)));
                System.Diagnostics.Debug.WriteLine("" + xa + " " + ya + " " + t);
                visitedGridPoints.Add(new PointF(grid * xa, grid * ya));
                visitedGridPoints.Add(new PointF(grid * xb, grid * yb));

                int xc;
                int yc;
                int xd;
                int yd;
                // Marschieren
                if(xa<xb)
                {
                    xc = xa;
                    yc = ya+1;
                    xd = xb;
                    yd = yb+1;
                }
                else if(yb>ya)
                {
                    xc = xa-1;
                    yc = ya;
                    xd = xb-1;
                    yd = yb;
                }
                else if(xb<xa)
                {
                    xc = xa;
                    yc = ya-1;
                    xd = xb;
                    yd = yb-1;
                }
                else
                {
                    xc = xa+1;
                    yc = ya;
                    xd = xb+1;
                    yd = yb;
                }
                visitedGridPoints.Add(new PointF(grid * xc, grid * yc));
                visitedGridPoints.Add(new PointF(grid * xd, grid * yd));

                double vc = f(grid*xc, grid*yc);
                double vd = f(grid*xd, grid*yd);

                if (vc < height)
                {
                    xb = xc;
                    yb = yc;
                    vb = vc;
                }
                else if(vd < height)
                {
                    xa = xc;
                    ya = yc;
                    va = vc;
                    xb = xd;
                    yb = yd;
                    vb = vd;
                }
                else
                {
                    xa = xd;
                    ya = yd;
                    va = vd;
                }
            }
            // Sind wir zurck am Ausgangspunkt?
            while(!(xa == x1 - 1 && ya == y && xb == x1 && yb == y));
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
            e.Graphics.DrawImage(bitmap, 0, 0);
            foreach (PointF p in visitedGridPoints)
            {
                e.Graphics.FillEllipse(Brushes.LightGreen, p.X - 1.0f, p.Y - 1.0f, 2.0f, 2.0f);
            }
            e.Graphics.DrawPolygon(Pens.Green, points.ToArray());
        }

        internal double f(double x, double y)
        {
            double x1 = Math.Abs(x-200.0)/250.0;
            double y1 = Math.Abs(y-200.0)/190.0;
            // Superellipse
            return 1.0 - Math.Sqrt(x1) - Math.Sqrt(y1);
        }
    }
}